diff mbox series

[v3] generic: add test for XFS forkoff miscalcution on 32-bit platform

Message ID 20201124101145.3230728-1-hsiangkao@redhat.com (mailing list archive)
State New, archived
Headers show
Series [v3] generic: add test for XFS forkoff miscalcution on 32-bit platform | expand

Commit Message

Gao Xiang Nov. 24, 2020, 10:11 a.m. UTC
There is a regression that recent XFS_LITINO(mp) update causes
xfs_attr_shortform_bytesfit() returns maxforkoff rather than 0.

Therefore, one result is
  "ASSERT(new_size <= XFS_IFORK_SIZE(ip, whichfork));"

Add a regression test in fstests generic to look after that since
the testcase itself isn't xfs-specific.

Signed-off-by: Gao Xiang <hsiangkao@redhat.com>
---
changes since v2:
 - "_require_no_xfs_bug_on_assert" to avoid crashing the system (Darrick);
 - refine a commit for more details (Darrick)

 tests/generic/618     | 75 +++++++++++++++++++++++++++++++++++++++++++
 tests/generic/618.out |  4 +++
 tests/generic/group   |  1 +
 3 files changed, 80 insertions(+)
 create mode 100755 tests/generic/618
 create mode 100644 tests/generic/618.out

Comments

Darrick J. Wong Nov. 24, 2020, 4:52 p.m. UTC | #1
On Tue, Nov 24, 2020 at 06:11:45PM +0800, Gao Xiang wrote:
> There is a regression that recent XFS_LITINO(mp) update causes
> xfs_attr_shortform_bytesfit() returns maxforkoff rather than 0.
> 
> Therefore, one result is
>   "ASSERT(new_size <= XFS_IFORK_SIZE(ip, whichfork));"
> 
> Add a regression test in fstests generic to look after that since
> the testcase itself isn't xfs-specific.
> 
> Signed-off-by: Gao Xiang <hsiangkao@redhat.com>

Looks good to me,
Reviewed-by: Darrick J. Wong <darrick.wong@oracle.com>

--D

> ---
> changes since v2:
>  - "_require_no_xfs_bug_on_assert" to avoid crashing the system (Darrick);
>  - refine a commit for more details (Darrick)
> 
>  tests/generic/618     | 75 +++++++++++++++++++++++++++++++++++++++++++
>  tests/generic/618.out |  4 +++
>  tests/generic/group   |  1 +
>  3 files changed, 80 insertions(+)
>  create mode 100755 tests/generic/618
>  create mode 100644 tests/generic/618.out
> 
> diff --git a/tests/generic/618 b/tests/generic/618
> new file mode 100755
> index 00000000..f1c1605e
> --- /dev/null
> +++ b/tests/generic/618
> @@ -0,0 +1,75 @@
> +#! /bin/bash
> +# SPDX-License-Identifier: GPL-2.0
> +# Copyright (c) 2020 Red Hat, Inc. All Rights Reserved.
> +#
> +# FS QA Test 618
> +#
> +# Verify that forkoff can be returned as 0 properly if it isn't
> +# able to fit inline for XFS.
> +# However, this test is fs-neutral and can be done quickly so
> +# leave it in generic
> +# This test verifies the problem fixed in kernel with commit
> +# ada49d64fb35 ("xfs: fix forkoff miscalculation related to XFS_LITINO(mp)")
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1	# failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> +	cd /
> +	rm -f $tmp.*
> +}
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/filter
> +. ./common/attr
> +
> +# remove previous $seqres.full before test
> +rm -f $seqres.full
> +
> +# real QA test starts here
> +
> +_supported_fs generic
> +_require_scratch
> +_require_attrs user
> +
> +if [ $FSTYP = "xfs" ]; then
> +	# avoid crashing the system if possible
> +	_require_no_xfs_bug_on_assert
> +
> +	# Use fixed inode size 512, so both v4 and v5 can be tested,
> +	# and also make sure the issue can be triggered if the default
> +	# inode size is changed later.
> +	MKFS_OPTIONS="$MKFS_OPTIONS -i size=512"
> +fi
> +
> +_scratch_mkfs > $seqres.full 2>&1
> +_scratch_mount
> +
> +localfile="${SCRATCH_MNT}/testfile"
> +touch $localfile
> +
> +# value cannot exceed XFS_ATTR_SF_ENTSIZE_MAX (256) or it will turn into leaf
> +# form directly; the following combination can trigger the issue for both v4
> +# (XFS_LITINO = 412) & v5 (XFS_LITINO = 336) fses, in details the 2nd setattr
> +# causes an integer underflow that is incorrectly typecast, leading to the
> +# assert triggering.
> +"${SETFATTR_PROG}" -n user.0 -v "`seq 0 80`" "${localfile}"
> +"${SETFATTR_PROG}" -n user.1 -v "`seq 0 80`" "${localfile}"
> +
> +# Make sure that changes are written to disk
> +_scratch_cycle_mount
> +
> +# getfattr won't succeed with the expected result if fails
> +_getfattr --absolute-names -ebase64 -d $localfile | tail -n +2 | sort
> +
> +_scratch_unmount
> +status=0
> +exit
> diff --git a/tests/generic/618.out b/tests/generic/618.out
> new file mode 100644
> index 00000000..848fdc58
> --- /dev/null
> +++ b/tests/generic/618.out
> @@ -0,0 +1,4 @@
> +QA output created by 618
> +
> +user.0=0sMAoxCjIKMwo0CjUKNgo3CjgKOQoxMAoxMQoxMgoxMwoxNAoxNQoxNgoxNwoxOAoxOQoyMAoyMQoyMgoyMwoyNAoyNQoyNgoyNwoyOAoyOQozMAozMQozMgozMwozNAozNQozNgozNwozOAozOQo0MAo0MQo0Mgo0Mwo0NAo0NQo0Ngo0Nwo0OAo0OQo1MAo1MQo1Mgo1Mwo1NAo1NQo1Ngo1Nwo1OAo1OQo2MAo2MQo2Mgo2Mwo2NAo2NQo2Ngo2Nwo2OAo2OQo3MAo3MQo3Mgo3Mwo3NAo3NQo3Ngo3Nwo3OAo3OQo4MA==
> +user.1=0sMAoxCjIKMwo0CjUKNgo3CjgKOQoxMAoxMQoxMgoxMwoxNAoxNQoxNgoxNwoxOAoxOQoyMAoyMQoyMgoyMwoyNAoyNQoyNgoyNwoyOAoyOQozMAozMQozMgozMwozNAozNQozNgozNwozOAozOQo0MAo0MQo0Mgo0Mwo0NAo0NQo0Ngo0Nwo0OAo0OQo1MAo1MQo1Mgo1Mwo1NAo1NQo1Ngo1Nwo1OAo1OQo2MAo2MQo2Mgo2Mwo2NAo2NQo2Ngo2Nwo2OAo2OQo3MAo3MQo3Mgo3Mwo3NAo3NQo3Ngo3Nwo3OAo3OQo4MA==
> diff --git a/tests/generic/group b/tests/generic/group
> index 94e860b8..eca9d619 100644
> --- a/tests/generic/group
> +++ b/tests/generic/group
> @@ -620,3 +620,4 @@
>  615 auto rw
>  616 auto rw io_uring stress
>  617 auto rw io_uring stress
> +618 auto quick attr
> -- 
> 2.18.4
>
diff mbox series

Patch

diff --git a/tests/generic/618 b/tests/generic/618
new file mode 100755
index 00000000..f1c1605e
--- /dev/null
+++ b/tests/generic/618
@@ -0,0 +1,75 @@ 
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2020 Red Hat, Inc. All Rights Reserved.
+#
+# FS QA Test 618
+#
+# Verify that forkoff can be returned as 0 properly if it isn't
+# able to fit inline for XFS.
+# However, this test is fs-neutral and can be done quickly so
+# leave it in generic
+# This test verifies the problem fixed in kernel with commit
+# ada49d64fb35 ("xfs: fix forkoff miscalculation related to XFS_LITINO(mp)")
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1	# failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+	cd /
+	rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/attr
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+
+_supported_fs generic
+_require_scratch
+_require_attrs user
+
+if [ $FSTYP = "xfs" ]; then
+	# avoid crashing the system if possible
+	_require_no_xfs_bug_on_assert
+
+	# Use fixed inode size 512, so both v4 and v5 can be tested,
+	# and also make sure the issue can be triggered if the default
+	# inode size is changed later.
+	MKFS_OPTIONS="$MKFS_OPTIONS -i size=512"
+fi
+
+_scratch_mkfs > $seqres.full 2>&1
+_scratch_mount
+
+localfile="${SCRATCH_MNT}/testfile"
+touch $localfile
+
+# value cannot exceed XFS_ATTR_SF_ENTSIZE_MAX (256) or it will turn into leaf
+# form directly; the following combination can trigger the issue for both v4
+# (XFS_LITINO = 412) & v5 (XFS_LITINO = 336) fses, in details the 2nd setattr
+# causes an integer underflow that is incorrectly typecast, leading to the
+# assert triggering.
+"${SETFATTR_PROG}" -n user.0 -v "`seq 0 80`" "${localfile}"
+"${SETFATTR_PROG}" -n user.1 -v "`seq 0 80`" "${localfile}"
+
+# Make sure that changes are written to disk
+_scratch_cycle_mount
+
+# getfattr won't succeed with the expected result if fails
+_getfattr --absolute-names -ebase64 -d $localfile | tail -n +2 | sort
+
+_scratch_unmount
+status=0
+exit
diff --git a/tests/generic/618.out b/tests/generic/618.out
new file mode 100644
index 00000000..848fdc58
--- /dev/null
+++ b/tests/generic/618.out
@@ -0,0 +1,4 @@ 
+QA output created by 618
+
+user.0=0sMAoxCjIKMwo0CjUKNgo3CjgKOQoxMAoxMQoxMgoxMwoxNAoxNQoxNgoxNwoxOAoxOQoyMAoyMQoyMgoyMwoyNAoyNQoyNgoyNwoyOAoyOQozMAozMQozMgozMwozNAozNQozNgozNwozOAozOQo0MAo0MQo0Mgo0Mwo0NAo0NQo0Ngo0Nwo0OAo0OQo1MAo1MQo1Mgo1Mwo1NAo1NQo1Ngo1Nwo1OAo1OQo2MAo2MQo2Mgo2Mwo2NAo2NQo2Ngo2Nwo2OAo2OQo3MAo3MQo3Mgo3Mwo3NAo3NQo3Ngo3Nwo3OAo3OQo4MA==
+user.1=0sMAoxCjIKMwo0CjUKNgo3CjgKOQoxMAoxMQoxMgoxMwoxNAoxNQoxNgoxNwoxOAoxOQoyMAoyMQoyMgoyMwoyNAoyNQoyNgoyNwoyOAoyOQozMAozMQozMgozMwozNAozNQozNgozNwozOAozOQo0MAo0MQo0Mgo0Mwo0NAo0NQo0Ngo0Nwo0OAo0OQo1MAo1MQo1Mgo1Mwo1NAo1NQo1Ngo1Nwo1OAo1OQo2MAo2MQo2Mgo2Mwo2NAo2NQo2Ngo2Nwo2OAo2OQo3MAo3MQo3Mgo3Mwo3NAo3NQo3Ngo3Nwo3OAo3OQo4MA==
diff --git a/tests/generic/group b/tests/generic/group
index 94e860b8..eca9d619 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -620,3 +620,4 @@ 
 615 auto rw
 616 auto rw io_uring stress
 617 auto rw io_uring stress
+618 auto quick attr